<div align="center">
  <p>
    <img src="static/logo.png" alt="dbots.js logo" width="200" />
  </p>
  <p>A stats poster and API wrapper for all botlists.</p>
  <p>
    <a href="https://www.npmjs.com/package/dbots">
      <img src="https://img.shields.io/npm/v/dbots.svg?maxAge=3600" alt="NPM version" />
    </a>
    <a href="https://www.npmjs.com/package/dbots">
      <img src="https://img.shields.io/npm/dt/dbots.svg?maxAge=3600" alt="NPM downloads" />
    </a>
    <br/>
    <a href="https://github.com/dbots-pkg/dbots.js/actions?query=workflow%3ATest">
      <img src="https://github.com/dbots-pkg/dbots.js/workflows/Test/badge.svg" alt="Tests" />
    </a>
    <a href="https://deepscan.io/dashboard#view=project&tid=11596&pid=14801&bid=284012">
      <img src="https://deepscan.io/api/teams/11596/projects/14801/branches/284011/badge/grade.svg" alt="DeepScan grade">
    </a>
    <a href="https://codecov.io/gh/dbots-pkg/dbots.js">
      <img src="https://codecov.io/gh/dbots-pkg/dbots.js/branch/master/graph/badge.svg?token=VRsBf9XHjN"/>
    </a>
  </p>
  <p>
    <a href="https://nodei.co/npm/dbots/"><img src="https://nodei.co/npm/dbots.png" alt="NPM info" /></a>
  </p>
</div>

<!-- omit in toc -->

# Table of Contents

- [About](#about)
- [Installing](#installing)
- [Supported Libraries](#supported-libraries)
- [Supported Services](#supported-services)
- [Changelog](#changelog)
- [Contribution](#contribution)
- [Other Links](#other-links)

## About

`dbots` helps [Discord](https://discordapp.com) bot developers group all your statistic posting needs into one poster, complete with separate posting, API wrappers for supported lists, and an interval to post to all services every `n` seconds.

## Installing

You can install dbots by running this command:

```sh
# Stable
npm i dbots
yarn add dbots

# Master
npm i dbots-pkg/dbots.js#master
yarn add ssh://github.com/dbots-pkg/dbots.js#master
```

## Supported Libraries

| Creator                           | Name                                                                                                                                   |
| --------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------- |
| Amish Shah (originally hydrabolt) | [![npm](static/npm.png)](https://npm.im/discord.js) [![GitHub](static/github.png)](https://github.com/discordjs/discord.js) discord.js |
| izy521                            | [![npm](static/npm.png)](https://npm.im/discord.io) [![GitHub](static/github.png)](https://github.com/izy521/discord.io) discord.io    |
| qeled                             | [![npm](static/npm.png)](https://npm.im/discordie) [![GitHub](static/github.png)](https://github.com/qeled/discordie) discordie        |
| abalabahaha                       | [![npm](static/npm.png)](https://npm.im/eris) [![GitHub](static/github.png)](https://github.com/abalabahaha/eris) eris                 |
| Lando                             | [![npm](static/npm.png)](https://npm.im/paracord) [![GitHub](static/github.png)](https://github.com/paracordjs/paracord) paracord      |

## Supported Services

The supported services list has been moved into the website.
You can see a full (and automatically updated) list of usable services [here](https://dbots.js.org/#/docs/main/latest/general/services).

## Changelog

You can see the changelog for every version [here](https://dbots.js.org/#/docs/main/latest/general/changelog).

## Contribution

Any contribution may be useful for the package! Make sure when making issues or PRs that the matter has not been addressed yet in a past issue/PR.

## Other Links

- [NPM](https://npmjs.org/package/dbots)
- [Yarn](https://yarn.pm/dbots)
- [JSDelivr](https://www.jsdelivr.com/package/npm/dbots)
- [Website](https://dbots.js.org) ([source](https://github.com/dbots-pkg/dbots-pkg.github.io))
- [Documentation](https://dbots.js.org/#/docs)
- [Dbots GitHub Organization](https://github.com/dbots-pkg)
