import { Service, ServicePostOptions } from '../Service';
import { IDResolvable } from '../../Utils/Util';
/**
 * Represents the BotlistMe service.
 * @see https://docs.botlist.me
 */
export default class BotlistMe extends Service {
    /** The values that can be used to select the service. */
    static get aliases(): string[];
    /** The logo URL. */
    static get logoURL(): string;
    /** Service's name. */
    static get serviceName(): string;
    /** The website URL. */
    static get websiteURL(): string;
    /** The base URL of the service's API. */
    static get baseURL(): string;
    /**
     * Posts statistics to this service.
     * <warn>Shard data posting is not supported for this service.</warn>
     * @param options The options of the request.
     */
    static post(options: ServicePostOptions): Promise<import("axios").AxiosResponse<any, any>>;
    /**
     * Gets whether a user has voted for a bot.
     * @param botID The bot's ID.
     * @param userID The user's ID.
     */
    userVoted(botID: IDResolvable, userID: IDResolvable): Promise<import("axios").AxiosResponse<any, any>>;
}
