import { Service, ServicePostOptions } from '../Service';
/**
 * Represents the DiscordBotlistEU service.
 * @see https://docs.discord-botlist.eu/
 */
export default class DiscordBotlistEU extends Service {
    /** The values that can be used to select the service. */
    static get aliases(): string[];
    /** The logo URL. */
    static get logoURL(): string;
    /** Service's name. */
    static get serviceName(): string;
    /** The website URL. */
    static get websiteURL(): string;
    /** The base URL of the service's API. */
    static get baseURL(): string;
    /**
     * Posts statistics to this service.
     * <warn>Shard data posting is not supported for this service.</warn>
     * @param options The options of the request
     */
    static post(options: ServicePostOptions): Promise<import("axios").AxiosResponse<any, any>>;
    /** Gets this bot */
    getBot(): Promise<import("axios").AxiosResponse<any, any>>;
    /** Gets this bot's analytics */
    getAnalytics(): Promise<import("axios").AxiosResponse<any, any>>;
    /** Gets the bot's votes */
    getVotes(): Promise<import("axios").AxiosResponse<any, any>>;
}
