import { Service, ServicePostOptions } from '../Service';
import { IDResolvable } from '../../Utils/Util';
/**
 * Represents the Infinity Bot List service.
 * @see https://spider.infinitybots.gg/docs
 */
export default class InfinityBotList extends Service {
    /** The values that can be used to select the service. */
    static get aliases(): string[];
    /** The logo URL. */
    static get logoURL(): string;
    /** Service's name. */
    static get serviceName(): string;
    /** The website URL. */
    static get websiteURL(): string;
    /** The base URL of the service's API. */
    static get baseURL(): string;
    /**
     * Posts statistics to this service.
     * @param options The options of the request.
     */
    static post(options: ServicePostOptions): Promise<import("axios").AxiosResponse<any, any>>;
    /**
     * Gets the bot listed on this service.
     * @param id The bot's ID.
     */
    getBot(id: IDResolvable): Promise<import("axios").AxiosResponse<any, any>>;
    /** Gets a list of all bots on this service. */
    getBots(): Promise<import("axios").AxiosResponse<any, any>>;
    /**
     * Gets the user listed on this service.
     * @param id The user's ID.
     */
    getUser(id: IDResolvable): Promise<import("axios").AxiosResponse<any, any>>;
}
